const APP_DISPLAY_NAME = "FoxyTunesSkin";
const APP_VERSION = "1.6";
const APP_SHORT_NAME = "foxytunes-skin";
const APP_AUTHOR = "iosart";
const APP_PACKAGE = "/" + APP_AUTHOR + "/" + APP_SHORT_NAME;
const APP_JAR_FILE = APP_SHORT_NAME + ".jar";
const BLD_ID_MOZILLA_MIN = 20040101; // 1.6
const APP_WHERE_MESSAGE = "Install " + APP_DISPLAY_NAME +
				" to your profile folder (OK) or to your program folder (Cancel) ?";
const APP_BUILD_TOO_OLD = APP_DISPLAY_NAME + " " + APP_VERSION 	+
				" must be installed to builds released after " +
				BLD_ID_MOZILLA_MIN + " !";

const APP_CONTENT_FOLDER = "content/";
const APP_SKIN_FOLDER	 = "skin/classic/";

function verifyNoError(errorMessage) {
	err = getLastError();

	if (err != SUCCESS) {
		alert(errorMessage + " (" + err + ")");
        	cancelInstall(err);
	}

	return err;
}

function perfromInstallation() {
	var err;

	// verify that the Mozilla build is not too old
	var currBuild = new String(buildID).substr(0, 8) - 0;
	if (currBuild && currBuild < BLD_ID_MOZILLA_MIN) {
	   alert(APP_BUILD_TOO_OLD);
   	   cancelInstall(INSTALL_NOT_STARTED);
	   return;
	}

        initInstall(APP_DISPLAY_NAME, APP_SHORT_NAME, APP_VERSION);
	if (verifyNoError("Couldn't init the installation process") != SUCCESS) { return; }

	// install chrome:
	var where, chromef;
	var inProfile = confirm(APP_WHERE_MESSAGE);
	if (inProfile) {
		chromef = getFolder("Profile", "chrome");
		where = PROFILE_CHROME;
   	} else {
		chromef = getFolder("chrome");
		where = DELAYED_CHROME;
   	}

    	addFile(APP_PACKAGE, APP_VERSION, "chrome/" + APP_JAR_FILE, chromef, null);
	err = verifyNoError("Failed to create " + APP_JAR_FILE + "\n" +
		            "You probably don't have appropriate permissions \n" +
		            "(write access to " + (inProfile ? "profile" : "browser") + "/chrome directory). \n"); 
	if (err != SUCCESS) { return; }

	var jar = getFolder(chromef, APP_JAR_FILE);

	registerChrome(CONTENT | where, jar, APP_CONTENT_FOLDER);
	if (verifyNoError("Couldn't register " + APP_CONTENT_FOLDER + " folder") != SUCCESS) { return; }

	registerChrome(SKIN    | where, jar, APP_SKIN_FOLDER);
	if (verifyNoError("Couldn't register " + APP_SKIN_FOLDER + " folder") != SUCCESS) { return; }

      	performInstall();

	err = getLastError();
	if (err == SUCCESS) {
            alert(APP_DISPLAY_NAME + " version " + APP_VERSION + " has been successfully installed to your " +
	               (inProfile?"profile":"program") + " folder.\n\n" +
		       "Please, restart the browser before continuing!");
      	} else {
		if (err == REBOOT_NEEDED) {
			alert("Install failed because a previous version of " + 
					APP_DISPLAY_NAME + " has not been uninstalled.");
		} else {
			alert("Install failed! Error code:" + err);
		}
		cancelInstall(err);
      	}
}

// Call the main installation function
perfromInstallation();
